Index: src/sas/sascalc/dataloader/readers/cansas_constants.py
===================================================================
--- src/sas/sascalc/dataloader/readers/cansas_constants.py	(revision d398285d1a07fbcba8a3328a6db3de09fb8581df)
+++ src/sas/sascalc/dataloader/readers/cansas_constants.py	(revision 250fec92ea66b0770da33360a90f022e1d674072)
@@ -27,5 +27,4 @@
         return_me.current_level = self.CANSAS_FORMAT.get("SASentry")
         # Defaults for variable and datatype
-        return_me.ns_variable = "{0}.meta_data[\"{2}\"] = \"{1}\""
         return_me.ns_datatype = "content"
         return_me.ns_optional = True
@@ -38,13 +37,10 @@
                         return_me.current_level = \
                                 return_me.current_level.get("<any>", "")
-                    cl_variable = return_me.current_level.get("variable", "")
                     cl_datatype = return_me.current_level.get("storeas", "")
                     cl_units_optional = \
-                             return_me.current_level.get("units_required", "")
+                             return_me.current_level.get("units_optional", "")
                     # Where are how to store the variable for the given
                     # namespace CANSAS_CONSTANTS tree is hierarchical, so
                     # is no value, inherit
-                    return_me.ns_variable = cl_variable if cl_variable != "" \
-                        else return_me.ns_variable
                     return_me.ns_datatype = cl_datatype if cl_datatype != "" \
                         else return_me.ns_datatype
@@ -53,5 +49,4 @@
                                         else return_me.ns_optional
             except AttributeError:
-                return_me.ns_variable = "{0}.meta_data[\"{2}\"] = \"{1}\""
                 return_me.ns_datatype = "content"
                 return_me.ns_optional = True
@@ -75,23 +70,12 @@
     # The constants below hold information on where to store the CanSAS data
     # when loaded in using sasview
-    META_DATA = "{0}.meta_data[\"{2}\"] = \"{1}\""
-    ANY = {"variable" : "{0}.meta_data[\"{2}\"] = \'{1}\'",
-           "storeas" : "content",
-          }
-    TITLE = {"variable" : "{0}.title = \"{1}\""}
-    SASNOTE = {"variable" : "{0}.notes.append(\'{1}\')"}
-    SASPROCESS_TERM = {"variable" : None,
-                       "attributes" : {"unit" : {"variable" : None},
-                                       "name" : {"variable" : None}
-                                      }
-                      }
-    SASPROCESS_SASPROCESSNOTE = {"variable" : None,
-                                 "children" : {"<any>" : ANY}
-                                }
-    SASPROCESS = {"variable" : None,
-                  "children" : {"name" : {"variable" : "{0}.name = \'{1}\'"},
-                                "date" : {"variable" : "{0}.date = \'{1}\'"},
-                                "description" :
-                                {"variable" : "{0}.description = \'{1}\'"},
+    ANY = {"storeas" : "content"}
+    TITLE = {}
+    SASNOTE = {}
+    SASPROCESS_TERM = {"attributes" : {"unit" : {}, "name" : {}}}
+    SASPROCESS_SASPROCESSNOTE = {"children" : {"<any>" : ANY}}
+    SASPROCESS = {"children" : {"name" : {},
+                                "date" : {},
+                                "description" : {},
                                 "term" : SASPROCESS_TERM,
                                 "SASprocessnote" : SASPROCESS_SASPROCESSNOTE,
@@ -99,74 +83,40 @@
                                },
                  }
-    RUN = {"variable" : "{0}.run.append(\"{1}\")",
-           "attributes" : {"name" :
-                           {"variable" : "{0}.run_name[\"{3}\"] = \"{1}\""}}
-          }
-    SASDATA_IDATA_Q = {"variable" : "{0}.x = numpy.append({0}.x, {1})",
-                       "unit" : "x_unit",
-                       "attributes" : {"unit" :
-                                       {"variable" : "{0}.xaxis(\"Q\", \'{1}\')",
-                                        "storeas" : "content"
-                                       }
-                                      },
-                      }
-    SASDATA_IDATA_I = {"variable" : "{0}.y = numpy.append({0}.y, {1})",
-                       "unit" : "y_unit",
-                       "attributes" : {"unit" :
-                                       {"variable" : "{0}.yaxis(\"Intensity\", \'{1}\')",
-                                        "storeas" : "content"
-                                       }
-                                      },
-                      }
-    SASDATA_IDATA_IDEV = {"variable" : "{0}.dy = numpy.append({0}.dy, {1})",
+    RUN = {"attributes" : {"name" :{}}}
+    SASDATA_IDATA_Q = {"units_optional" : False,
+                       "storeas" : "float",
+                        "unit" : "x_unit",
+                       "attributes" : {"unit" : {"storeas" : "content"}},
+                      }
+    SASDATA_IDATA_I = {"units_optional" : False,
+                       "storeas" : "float",
+                        "unit" : "y_unit",
+                       "attributes" : {"unit" : {"storeas" : "content"}},
+                      }
+    SASDATA_IDATA_IDEV = {"units_optional" : False,
+                          "storeas" : "float",
                           "unit" : "y_unit",
-                          "attributes" : {"unit" :
-                                          {"variable" : META_DATA,
-                                           "storeas" : "content"
-                                          }
-                                         },
-                         }
-    SASDATA_IDATA_QDEV = {"variable" : "{0}.dx = numpy.append({0}.dx, {1})",
+                          "attributes" : {"unit" : {"storeas" : "content"}},
+                         }
+    SASDATA_IDATA_QDEV = {"units_optional" : False,
+                          "storeas" : "float",
                           "unit" : "x_unit",
-                          "attributes" : {"unit" :
-                                          {"variable" : META_DATA,
-                                           "storeas" : "content"
-                                          }
-                                         },
-                         }
-    SASDATA_IDATA_DQL = {"variable" : "{0}.dxl = numpy.append({0}.dxl, {1})",
+                          "attributes" : {"unit" : {"storeas" : "content"}},
+                         }
+    SASDATA_IDATA_DQL = {"units_optional" : False,
+                         "storeas" : "float",
                          "unit" : "x_unit",
-                         "attributes" : {"unit" :
-                                         {"variable" : META_DATA,
-                                          "storeas" : "content"
-                                         }
-                                        },
-                        }
-    SASDATA_IDATA_DQW = {"variable" : "{0}.dxw = numpy.append({0}.dxw, {1})",
+                         "attributes" : {"unit" : {"storeas" : "content"}},
+                        }
+    SASDATA_IDATA_DQW = {"units_optional" : False,
+                         "storeas" : "float",
                          "unit" : "x_unit",
-                         "attributes" : {"unit" :
-                                         {"variable" : META_DATA,
-                                          "storeas" : "content"
-                                         }
-                                        },
-                        }
-    SASDATA_IDATA_QMEAN = {"storeas" : "content",
-                           "unit" : "x_unit",
-                           "variable" : META_DATA,
-                           "attributes" : {"unit" : {"variable" : META_DATA}},
+                         "attributes" : {"unit" : {"storeas" : "content"}},
+                        }
+    SASDATA_IDATA_QMEAN = {"unit" : "x_unit",
+                           "attributes" : {"unit" : {}},
                           }
-    SASDATA_IDATA_SHADOWFACTOR = {"variable" : META_DATA,
-                                  "storeas" : "content",
-                                 }
-    SASDATA_IDATA = {"storeas" : "float",
-                     "units_optional" : False,
-                     "variable" : None,
-                     "attributes" : {"name" : {"variable" : META_DATA,
-                                               "storeas" : "content",
-                                              },
-                                     "timestamp" : {"variable" : META_DATA,
-                                                    "storeas" : "timestamp",
-                                                   }
-                                    },
+    SASDATA_IDATA_SHADOWFACTOR = {}
+    SASDATA_IDATA = {"attributes" : {"name" : {},"timestamp" : {"storeas" : "timestamp"}},
                      "children" : {"Q" : SASDATA_IDATA_Q,
                                    "I" : SASDATA_IDATA_I,
@@ -180,5 +130,5 @@
                                   }
                     }
-    SASDATA = {"attributes" : {"name" : {"variable" : META_DATA,}},
+    SASDATA = {"attributes" : {"name" : {}},
                "variable" : None,
                "children" : {"Idata" : SASDATA_IDATA,
@@ -186,36 +136,17 @@
                             }
               }
-    SASTRANSSPEC_TDATA_LAMDBA = {"variable" : "{0}.wavelength.append({1})",
+    SASTRANSSPEC_TDATA_LAMDBA = {"storeas" : "float",
                                  "unit" : "wavelength_unit",
-                                 "attributes" :
-                                 {"unit" :
-                                  {"variable" : "{0}.wavelength_unit = \"{1}\"",
-                                   "storeas" : "content"
-                                  }
-                                 }
+                                 "attributes" : {"unit" : {"storeas" : "content"}}
                                 }
-    SASTRANSSPEC_TDATA_T = {"variable" : "{0}.transmission.append({1})",
+    SASTRANSSPEC_TDATA_T = {"storeas" : "float",
                             "unit" : "transmission_unit",
-                            "attributes" :
-                            {"unit" :
-                             {"variable" : "{0}.transmission_unit = \"{1}\"",
-                              "storeas" : "content"
-                             }
-                            }
-                           }
-    SASTRANSSPEC_TDATA_TDEV = {"variable" :
-                               "{0}.transmission_deviation.append({1})",
+                            "attributes" : {"unit" : {"storeas" : "content"}}
+                           }
+    SASTRANSSPEC_TDATA_TDEV = {"storeas" : "float",
                                "unit" : "transmission_deviation_unit",
-                               "attributes" :
-                               {"unit" :
-                                {"variable" :
-                                 "{0}.transmission_deviation_unit = \"{1}\"",
-                                 "storeas" : "content"
-                                }
-                               }
-                              }
-    SASTRANSSPEC_TDATA = {"storeas" : "float",
-                          "variable" : None,
-                          "children" : {"Lambda" : SASTRANSSPEC_TDATA_LAMDBA,
+                               "attributes" : {"unit" :{"storeas" : "content"}}
+                              }
+    SASTRANSSPEC_TDATA = {"children" : {"Lambda" : SASTRANSSPEC_TDATA_LAMDBA,
                                         "T" : SASTRANSSPEC_TDATA_T,
                                         "Tdev" : SASTRANSSPEC_TDATA_TDEV,
@@ -223,87 +154,50 @@
                                        }
                          }
-    SASTRANSSPEC = {"variable" : None,
-                    "children" : {"Tdata" : SASTRANSSPEC_TDATA,
+    SASTRANSSPEC = {"children" : {"Tdata" : SASTRANSSPEC_TDATA,
                                   "<any>" : ANY,
                                  },
-                    "attributes" :
-                    {"name" :
-                     {"variable" : "{0}.name = \"{1}\""},
-                     "timestamp" :
-                     {"variable" : "{0}.timestamp = \"{1}\""},
-                    }
+                    "attributes" : {"name" :{}, "timestamp" : {},}
                    }
-    SASSAMPLE_THICK = {"variable" : "{0}.sample.thickness = {1}",
-                       "unit" : "sample.thickness_unit",
-                       "storeas" : "float",
-                       "attributes" :
-                       {"unit" :
-                        {"variable" : "{0}.sample.thickness_unit = \"{1}\"",
-                         "storeas" : "content"
-                        }
-                       },
-                      }
-    SASSAMPLE_TRANS = {"variable" : "{0}.sample.transmission = {1}",
-                       "storeas" : "float",
-                      }
-    SASSAMPLE_TEMP = {"variable" : "{0}.sample.temperature = {1}",
-                      "unit" : "sample.temperature_unit",
+    SASSAMPLE_THICK = {"unit" : "thickness_unit",
+                       "storeas" : "float",
+                       "attributes" : {"unit" :{}},
+                      }
+    SASSAMPLE_TRANS = {"storeas" : "float",}
+    SASSAMPLE_TEMP = {"unit" : "temperature_unit",
                       "storeas" : "float",
-                      "attributes" :
-                      {"unit" :
-                       {"variable" : "{0}.sample.temperature_unit = \"{1}\"",
-                        "storeas" : "content"
-                       }
-                      },
+                      "attributes" :{"unit" :{}},
                      }
-    SASSAMPLE_POS_ATTR = {"unit" : {"variable" :
-                                    "{0}.sample.position_unit = \"{1}\"",
-                                    "storeas" : "content"
-                                   }
-                         }
-    SASSAMPLE_POS_X = {"variable" : "{0}.sample.position.x = {1}",
-                       "unit" : "sample.position_unit",
+    SASSAMPLE_POS_ATTR = {"unit" : {}}
+    SASSAMPLE_POS_X = {"unit" : "position_unit",
                        "storeas" : "float",
                        "attributes" : SASSAMPLE_POS_ATTR
                       }
-    SASSAMPLE_POS_Y = {"variable" : "{0}.sample.position.y = {1}",
-                       "unit" : "sample.position_unit",
+    SASSAMPLE_POS_Y = {"unit" : "position_unit",
                        "storeas" : "float",
                        "attributes" : SASSAMPLE_POS_ATTR
                       }
-    SASSAMPLE_POS_Z = {"variable" : "{0}.sample.position.z = {1}",
-                       "unit" : "sample.position_unit",
+    SASSAMPLE_POS_Z = {"unit" : "position_unit",
                        "storeas" : "float",
                        "attributes" : SASSAMPLE_POS_ATTR
                       }
-    SASSAMPLE_POS = {"children" : {"variable" : None,
-                                   "x" : SASSAMPLE_POS_X,
+    SASSAMPLE_POS = {"children" : {"x" : SASSAMPLE_POS_X,
                                    "y" : SASSAMPLE_POS_Y,
                                    "z" : SASSAMPLE_POS_Z,
                                   },
                     }
-    SASSAMPLE_ORIENT_ATTR = {"unit" :
-                             {"variable" :
-                              "{0}.sample.orientation_unit = \"{1}\"",
-                              "storeas" : "content"
-                             }
-                            }
-    SASSAMPLE_ORIENT_ROLL = {"variable" : "{0}.sample.orientation.x = {1}",
-                             "unit" : "sample.orientation_unit",
+    SASSAMPLE_ORIENT_ATTR = {"unit" :{}}
+    SASSAMPLE_ORIENT_ROLL = {"unit" : "orientation_unit",
                              "storeas" : "float",
                              "attributes" : SASSAMPLE_ORIENT_ATTR
                             }
-    SASSAMPLE_ORIENT_PITCH = {"variable" : "{0}.sample.orientation.y = {1}",
-                              "unit" : "sample.orientation_unit",
+    SASSAMPLE_ORIENT_PITCH = {"unit" : "orientation_unit",
                               "storeas" : "float",
                               "attributes" : SASSAMPLE_ORIENT_ATTR
                              }
-    SASSAMPLE_ORIENT_YAW = {"variable" : "{0}.sample.orientation.z = {1}",
-                            "unit" : "sample.orientation_unit",
+    SASSAMPLE_ORIENT_YAW = {"unit" : "orientation_unit",
                             "storeas" : "float",
                             "attributes" : SASSAMPLE_ORIENT_ATTR
                            }
-    SASSAMPLE_ORIENT = {"variable" : None,
-                        "children" : {"roll" : SASSAMPLE_ORIENT_ROLL,
+    SASSAMPLE_ORIENT = {"children" : {"roll" : SASSAMPLE_ORIENT_ROLL,
                                       "pitch" : SASSAMPLE_ORIENT_PITCH,
                                       "yaw" : SASSAMPLE_ORIENT_YAW,
@@ -311,7 +205,6 @@
                        }
     SASSAMPLE = {"attributes" :
-                 {"name" : {"variable" : "{0}.sample.name = \"{1}\""},},
-                 "variable" : None,
-                 "children" : {"ID" : {"variable" : "{0}.sample.ID = \"{1}\""},
+                 {"name" : {},},
+                 "children" : {"ID" : {},
                                "thickness" : SASSAMPLE_THICK,
                                "transmission" : SASSAMPLE_TRANS,
@@ -319,33 +212,22 @@
                                "position" : SASSAMPLE_POS,
                                "orientation" : SASSAMPLE_ORIENT,
-                               "details" :
-                               {"variable" :
-                                "{0}.sample.details.append(\"{1}\")"},
+                               "details" : {},
                                "<any>" : ANY
                               },
                 }
-    SASINSTR_SRC_BEAMSIZE_ATTR = {"unit" :
-                                  "{0}.source.beam_size_unit = \"{1}\"",
-                                  "storeas" : "content"
-                                 }
-    SASINSTR_SRC_BEAMSIZE_X = {"variable" : "{0}.source.beam_size.x = {1}",
-                               "unit" : "source.beam_size_unit",
+    SASINSTR_SRC_BEAMSIZE_ATTR = {"unit" : ""}
+    SASINSTR_SRC_BEAMSIZE_X = {"unit" : "beam_size_unit",
                                "storeas" : "float",
                                "attributes" : SASINSTR_SRC_BEAMSIZE_ATTR
                               }
-    SASINSTR_SRC_BEAMSIZE_Y = {"variable" : "{0}.source.beam_size.y = {1}",
-                               "unit" : "source.beam_size_unit",
+    SASINSTR_SRC_BEAMSIZE_Y = {"unit" : "beam_size_unit",
                                "storeas" : "float",
                                "attributes" : SASINSTR_SRC_BEAMSIZE_ATTR
                               }
-    SASINSTR_SRC_BEAMSIZE_Z = {"variable" : "{0}.source.beam_size.z = {1}",
-                               "unit" : "source.beam_size_unit",
+    SASINSTR_SRC_BEAMSIZE_Z = {"unit" : "beam_size_unit",
                                "storeas" : "float",
                                "attributes" : SASINSTR_SRC_BEAMSIZE_ATTR
                               }
-    SASINSTR_SRC_BEAMSIZE = {"attributes" :
-                             {"name" : {"variable" :
-                                        "{0}.source.beam_size_name = \"{1}\""}},
-                             "variable" : None,
+    SASINSTR_SRC_BEAMSIZE = {"attributes" : {"name" : {}},
                              "children" : {"x" : SASINSTR_SRC_BEAMSIZE_X,
                                            "y" : SASINSTR_SRC_BEAMSIZE_Y,
@@ -353,57 +235,25 @@
                                           }
                             }
-    SASINSTR_SRC_WL = {"variable" : "{0}.source.wavelength = {1}",
-                       "unit" : "source.wavelength_unit",
-                       "storeas" : "float",
-                       "attributes" :
-                       {"unit" :
-                        {"variable" : "{0}.source.wavelength_unit = \"{1}\"",
-                         "storeas" : "content"
-                        },
+    SASINSTR_SRC_WL = {"unit" : "wavelength_unit",
+                       "storeas" : "float",
+                       "attributes" : {"unit" :{},
                        }
                       }
-    SASINSTR_SRC_WL_MIN = {"variable" : "{0}.source.wavelength_min = {1}",
-                           "unit" : "source.wavelength_min_unit",
+    SASINSTR_SRC_WL_MIN = {"unit" : "wavelength_min_unit",
                            "storeas" : "float",
-                           "attributes" :
-                           {"unit" :
-                            {"variable" :
-                             "{0}.source.wavelength_min_unit = \"{1}\"",
-                             "storeas" : "content"
-                            },
-                           }
+                           "attributes" : {"unit" :{"storeas" : "content"},}
                           }
-    SASINSTR_SRC_WL_MAX = {"variable" : "{0}.source.wavelength_max = {1}",
-                           "unit" : "source.wavelength_max_unit",
+    SASINSTR_SRC_WL_MAX = {"unit" : "wavelength_max_unit",
                            "storeas" : "float",
-                           "attributes" :
-                           {"unit" :
-                            {"variable" :
-                             "{0}.source.wavelength_max_unit = \"{1}\"",
-                             "storeas" : "content"
-                            },
-                           }
+                           "attributes" : {"unit" :{"storeas" : "content"},}
                           }
-    SASINSTR_SRC_WL_SPR = {"variable" : "{0}.source.wavelength_spread = {1}",
-                           "unit" : "source.wavelength_spread_unit",
+    SASINSTR_SRC_WL_SPR = {"unit" : "wavelength_spread_unit",
                            "storeas" : "float",
-                           "attributes" :
-                           {"unit" :
-                            {"variable" :
-                             "{0}.source.wavelength_spread_unit = \"{1}\"",
-                             "storeas" : "content"
-                            },
-                           }
+                           "attributes" : {"unit" : {"storeas" : "content"},}
                           }
-    SASINSTR_SRC = {"attributes" : {"name" : {"variable" :
-                                              "{0}.source.name = \"{1}\""}},
-                    "variable" : None,
-                    "children" : {"radiation" :
-                                  {"variable" :
-                                   "{0}.source.radiation = \"{1}\""},
+    SASINSTR_SRC = {"attributes" : {"name" : {}},
+                    "children" : {"radiation" : {},
                                   "beam_size" : SASINSTR_SRC_BEAMSIZE,
-                                  "beam_shape" :
-                                  {"variable" :
-                                   "{0}.source.beam_shape = \"{1}\""},
+                                  "beam_shape" : {},
                                   "wavelength" : SASINSTR_SRC_WL,
                                   "wavelength_min" : SASINSTR_SRC_WL_MIN,
@@ -412,26 +262,18 @@
                                  },
                    }
-    SASINSTR_COLL_APER_ATTR = {"unit" : {"variable" : "{0}.size_unit = \"{1}\"",
-                                         "storeas" : "content"
-                                        },
-                              }
-    SASINSTR_COLL_APER_X = {"variable" : "{0}.size.x = {1}",
-                            "unit" : "size_unit",
+    SASINSTR_COLL_APER_ATTR = {"unit" : {}}
+    SASINSTR_COLL_APER_X = {"unit" : "size_unit",
                             "storeas" : "float",
                             "attributes" : SASINSTR_COLL_APER_ATTR
                            }
-    SASINSTR_COLL_APER_Y = {"variable" : "{0}.size.y = {1}",
-                            "unit" : "size_unit",
+    SASINSTR_COLL_APER_Y = {"unit" : "size_unit",
                             "storeas" : "float",
                             "attributes" : SASINSTR_COLL_APER_ATTR
                            }
-    SASINSTR_COLL_APER_Z = {"variable" : "{0}.size.z = {1}",
-                            "unit" : "size_unit",
+    SASINSTR_COLL_APER_Z = {"unit" : "size_unit",
                             "storeas" : "float",
                             "attributes" : SASINSTR_COLL_APER_ATTR
                            }
-    SASINSTR_COLL_APER_SIZE = {"attributes" :
-                               {"unit" : {"variable" :
-                                          "{0}.size_unit = \"{1}\""}},
+    SASINSTR_COLL_APER_SIZE = {"attributes" : {"unit" : {}},
                                "children" : {"storeas" : "float",
                                              "x" : SASINSTR_COLL_APER_X,
